diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
index ee443af20..d0cb4cb83 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
@@ -1,76 +1,95 @@
 package net.minecraft.client.gui.hud.component.layout;
 
+import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
-import net.minecraft.client.option.GameSettings;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class LayoutSnap
-    extends Layout {
-    private HudComponent parent;
-    private ComponentAnchor parentAnchor;
-    private ComponentAnchor anchor;
+public class LayoutSnap extends Layout {
+    private @Nullable HudComponent parent;
+    private @NotNull ComponentAnchor parentAnchor;
+    private @NotNull ComponentAnchor anchor;
+    private int xOffset;
+    private int yOffset;
 
-    public LayoutSnap(HudComponent parent, ComponentAnchor parentAnchor, ComponentAnchor anchor) {
+    public LayoutSnap(@Nullable HudComponent parent, @NotNull ComponentAnchor parentAnchor, @NotNull ComponentAnchor anchor) {
+        this(parent, parentAnchor, anchor, 0, 0);
+    }
+
+    public LayoutSnap(@Nullable HudComponent parent, @NotNull ComponentAnchor parentAnchor, @NotNull ComponentAnchor anchor, int xOffset, int yOffset) {
         this.parent = parent;
         this.parentAnchor = parentAnchor;
         this.anchor = anchor;
+        this.xOffset = xOffset;
+        this.yOffset = yOffset;
     }
 
-    public HudComponent getParent() {
-        return this.parent;
-    }
+    public @Nullable HudComponent getParent() { return this.parent; }
+    public @NotNull ComponentAnchor getParentAnchor() { return this.parentAnchor; }
+    public @NotNull ComponentAnchor getAnchor() { return this.anchor; }
+    public int getXOffset() { return this.xOffset; }
+    public int getYOffset() { return this.yOffset; }
 
-    public ComponentAnchor getParentAnchor() {
-        return this.parentAnchor;
-    }
+    public void setParent(@Nullable HudComponent parent) { this.parent = parent; }
+    public void setParentAnchor(@NotNull ComponentAnchor parentAnchor) { this.parentAnchor = parentAnchor; }
+    public void setAnchor(@NotNull ComponentAnchor anchor) { this.anchor = anchor; }
+    public void setXOffset(int xOffset) { this.xOffset = xOffset; }
+    public void setYOffset(int yOffset) { this.yOffset = yOffset; }
 
-    public ComponentAnchor getAnchor() {
-        return this.anchor;
-    }
+    @Override
+    public int getComponentX(@NotNull HudComponent component, int xSizeScreen) {
+        if (this.parent == null) {
+            return (int) (xSizeScreen * this.parentAnchor.xPosition) - component.getTrueAnchorX(this.anchor) + this.xOffset;
+        }
 
-    public void setParent(HudComponent parent) {
-        this.parent = parent;
-    }
+        int posX = this.parent.getLayout().getComponentX(this.parent, xSizeScreen)
+                - component.getTrueAnchorX(this.anchor)
+                + this.parent.getTrueAnchorX(this.parentAnchor);
 
-    public void setParentAnchor(ComponentAnchor parentAnchor) {
-        this.parentAnchor = parentAnchor;
-    }
+        if (!this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
+            float collapseDirection = this.anchor.xPosition - this.parentAnchor.xPosition;
+            posX += (int) (collapseDirection * this.parent.getTrueXSize());
+        } else {
+            posX += this.xOffset;
+        }
 
-    public void setAnchor(ComponentAnchor anchor) {
-        this.anchor = anchor;
+        return posX;
     }
 
     @Override
-    public int getComponentX(HudComponent component, int xSizeScreen) {
+    public int getComponentY(@NotNull HudComponent component, int ySizeScreen) {
         if (this.parent == null) {
-            int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-            return (int) (xSizeScreen * this.parentAnchor.xPosition) - component.getAnchorX(this.anchor) + sp;
+            return (int) (ySizeScreen * this.parentAnchor.yPosition) - component.getTrueAnchorY(this.anchor) + this.yOffset;
         }
-        return this.parent.getLayout().getComponentX(this.parent, xSizeScreen) - component.getAnchorX(this.anchor) + this.parent.getAnchorX(this.parentAnchor);
-    }
 
-    @Override
-    public int getComponentY( HudComponent component, int ySizeScreen) {
-        if (this.parent == null) {
-            int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-            return (int) (ySizeScreen * this.parentAnchor.yPosition) - component.getAnchorY(this.anchor) + sp;
+        int posY = this.parent.getLayout().getComponentY(this.parent, ySizeScreen)
+                - component.getTrueAnchorY(this.anchor)
+                + this.parent.getTrueAnchorY(this.parentAnchor);
+
+        if (!this.parent.isVisible() && !(mc.currentScreen instanceof ScreenHudEditor)) {
+            float collapseDirection = this.anchor.yPosition - this.parentAnchor.yPosition;
+            posY += (int) (collapseDirection * this.parent.getTrueYSize());
+        } else {
+            posY += this.yOffset;
         }
-        return this.parent.getLayout().getComponentY(this.parent, ySizeScreen) - component.getAnchorY(this.anchor) + this.parent.getAnchorY(this.parentAnchor);
+
+        return posY;
     }
 
     @Override
-    public Layout copy() {
-        return new LayoutSnap(this.parent, this.parentAnchor, this.anchor);
+    public @NotNull Layout copy() {
+        return new LayoutSnap(this.parent, this.parentAnchor, this.anchor, this.xOffset, this.yOffset);
     }
 
     @Override
-    public String toSettingsString() {
-        return (this.parent == null ? "null" : this.parent.getKey()) + "," + this.parentAnchor.name() + "," + this.anchor.name();
+    public @NotNull String toSettingsString() {
+        return (this.parent == null ? "null" : this.parent.getKey()) + "," + this.parentAnchor.name() + "," + this.anchor.name() + "," + this.xOffset + "," + this.yOffset;
     }
 
     @Override
-    public void fromSettingsString(String settings) {
+    public void fromSettingsString(@NotNull String settings) {
         String[] parts = settings.split(",");
         if (parts[0].equals("null")) {
             this.parent = null;
@@ -79,5 +98,13 @@ public class LayoutSnap
         }
         this.parentAnchor = ComponentAnchor.valueOf(parts[1]);
         this.anchor = ComponentAnchor.valueOf(parts[2]);
+
+        if (parts.length > 3) {
+            this.xOffset = Integer.parseInt(parts[3]);
+            this.yOffset = Integer.parseInt(parts[4]);
+        } else {
+            this.xOffset = 0;
+            this.yOffset = 0;
+        }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
index 76e5084c4..ec9d54161 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
@@ -42,6 +42,7 @@ public class KeyBindingComponent
     @Override
     protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY)
     {
+        this.keyButton.displayString = this.keyBinding.getKeyName();
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
         this.keyButton.xPosition = x + relativeButtonX;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index ed1f20033..601296ecc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -83,14 +83,12 @@ public abstract class OptionsPages {
             .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
                 .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new ScreenHudEditor(mc.currentScreen))))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.GUI_SCALE).applyOnRelease())
-                .withComponent(new FloatOptionComponent(GameSettings.SCREEN_PADDING))
                 .withComponent(new TooltipPickerComponent(GameSettings.TOOLTIP_STYLE))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.FONT))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.chatVisibility))
                 .withComponent(new BooleanOptionComponent(GameSettings.FPS_IN_OVERLAY))
                 .withComponent(new BooleanOptionComponent(GameSettings.VERSION_IN_OVERLAY))
                 .withComponent(new BooleanOptionComponent(GameSettings.FOOD_HEALTH_REGEN_OVERLAY))
-                .withComponent(new BooleanOptionComponent(GameSettings.HELD_ITEM_TOOLTIPS))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.ITEM_DESCRIPTIONS))
                 .withComponent(new BooleanOptionComponent(GameSettings.HIDE_UNDISCOVERED_ITEMS))
                 .withComponent(new BooleanOptionComponent(GameSettings.DYNAMIC_CURSOR))
@@ -246,9 +244,21 @@ public abstract class OptionsPages {
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_PLAYER_LIST))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_HIDE_GUI))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_DEBUG))
-                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_OVERLAY))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_INFO_OVERLAY))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_SORT_INVENTORY))
             )
+            .withComponent(new OptionsCategory("gui.options.page.controls.category.hud_editor")
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_SELECT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_OPEN_CONTEXT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_NUDGE_UP))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_NUDGE_DOWN))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_NUDGE_LEFT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_NUDGE_RIGHT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_NUDGE_FAST))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_RESET))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_EXIT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_HUD_EDITOR_ONBOARDING))
+            )
             .withComponent(new OptionsCategory("gui.options.page.controls.category.hotbar")
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_HOT_BAR_LEFT))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_HOT_BAR_RIGHT))
@@ -289,7 +299,6 @@ public abstract class OptionsPages {
             .withComponent(new OptionsCategory("gui.options.page.accessibility.category.accessibility")
                 .withComponent(new BooleanOptionComponent(GameSettings.SUBTITLES))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.GUI_SCALE).applyOnRelease())
-                .withComponent(new FloatOptionComponent(GameSettings.SCREEN_PADDING))
                 .withComponent(new BooleanOptionComponent(GameSettings.VIEW_BOBBING))
                 .withComponent(new BooleanOptionComponent(GameSettings.FOV_MODIFICATION))
                 .withComponent(new BooleanOptionComponent(GameSettings.SCREEN_MOTION_EFFECTS))
@@ -451,14 +460,5 @@ public abstract class OptionsPages {
                     if (Minecraft.getMinecraft().currentWorld != null) Minecraft.getMinecraft().currentWorld.getCommandManager().reload();
                 }))
             ));
-        HIDDEN = register(new OptionsPageHidden("gui.options.page.hidden.title", new ItemStack(Blocks.GLASS_TINTED))
-            .withComponent(new OptionsCategory("gui.options.page.hidden.category.general")
-                .withComponent(new OptionsCategory("gui.options.page.hidden.category.general.userinterface")
-                    .withComponent(new BooleanOptionComponent(GameSettings.ARMOR_DURABILITY_OVERLAY))
-                    .withComponent(new BooleanOptionComponent(GameSettings.ARMOR_BAR_OVERLAY))
-                    .withComponent(new BooleanOptionComponent(GameSettings.HELD_ITEM_COUNT_OVERLAY))
-                )
-            )
-        );
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
index 49ad359e7..830b7e6a7 100644
--- a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.input;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
@@ -70,7 +71,7 @@ public class PlayerInput {
 
 		if(GameSettings.KEY_EASY_BRIDGE.isKeyOrMouse(keyCode, mouseCode) && pressed) {
 			GameSettings.EASY_BRIDGE.toggle();
-            this.mc.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(GameSettings.EASY_BRIDGE);
+			HudComponents.DYNAMIC_TOOLTIP.setOptionNameAndValueString(GameSettings.EASY_BRIDGE);
 		}
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index d1a1249d3..8f7eb7252 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -3,6 +3,7 @@ package net.minecraft.client.net.handler;
 import com.b100.utils.StringUtils;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.render.particle.ParticlePickupAnimation;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.entity.player.PlayerRemote;
@@ -544,7 +545,7 @@ public class PacketHandlerClient extends PacketHandler {
 
         int type = packet.type;
         if (type == 1) {
-            this.mc.hudIngame.heldItemTooltipElement.setString(message);
+            HudComponents.DYNAMIC_TOOLTIP.setString(message);
         } else {
             this.mc.hudIngame.addChatMessage(message);
         }
